#include <stdio.h>
#include <stdlib.h>
#include <math.h>  /*for rounding float return*/
#include "InpOut32.h"

/*declarations imported from header*/
int InitGSComms(void);
int CloseGSComms(void);
int GSFcn1(int);
int SendNibble(int);
int ReadWriteNibble(int);
int ReadWriteByte(int);
unsigned int ReadWrite16(unsigned int x);
unsigned long ReadWrite32(unsigned long);
int CheckGSPresence(void);

unsigned long Read32(unsigned long address);
unsigned short Read16(unsigned long address);
unsigned char ReadByte(unsigned long address);

int checkered();
int erratta(int code);
int grabbity(int reg);
int statistic(int reg);
/*Sorry ahead of time.  I'm a rambler
GE Position Locator v1.0
c/o Zoinkity (nefariousdogooder@yahoo.com)

A very, very simple app that pulls player positions.
The idea is to somewhat ease the annoyance of getting and translating positions 
for inserting in custom setup files.

This uses InpOut32.dll, which should either be with the program or in your windows System or System32 folder.
Why?  Because winXP buggered the comms port, that's why.

This thing only works on the NTSC-North American Rom.  Why?  I'm lazy.
The region detection is fudged.  If you'd like to help getting proper region detection,
try this:  make a log of a code list or rom download.
Heck, make one of an upload while you're at it.
The transfer protocal for rom isn't known, and this returns a funny swapped sort of thing.


The jist of the operation:
    get timeout value (or create a new ini if not found)
    check if right rom loaded.  Done once at execution.
    NOT NECESSARY * grab # players value - 8002B523 *
    grab, check, and store four player handles @ 80079EE0/4/8/C
on user select:
    grab stage scale from 800413F4; store as float
    inc address 0xA8; grab address at result
    pull 0x8,0xC,0x10 [x,y,z positions] 
    pull 0x14;  jump to address, and convert tile header to Pvalue
    for untranslated (unexpanded) position, divided all values by stage scale

Pvalue Conversion:
    all start with 'P'
    first two bytes of tile are unsigned int value in decimal
    next byte is divided by 8 and added to 0x61.  The remainder is displayed.
    
Display:
    current   unexpanded
    xpos      xpos
    ypos      ypos
    zpos      zpos
    Proom     Pvalue
*/

/*this is a slight convenience
it keeps track of whether the comms are connected 1=no, 0=yes
most times this isn't necessary, but it helps when aborting the program*/
int stateflag=1;

/*warning - this will probably get very ugly...*/
int main(int argc, char *argv[])
{int reg,c;

for(;;)
{

for(c=0;c==0;)                    /*main menu loop*/
{system("CLS");
printf("\nGE Position Locator v1.0 (console)\nc/o Zoinkity (nefariousdogooder@yahoo.com)\n");
fflush(stdin);
printf("\n1\tGrab Player Positions");
printf("\n2\tView Player Stats");
printf("\n---------\n-Any Other Key To Quit-\n");

switch(getchar())
      {case '1':
            c=1; break;
       case '2':
            c=2; break;
       default:
               return 0; break;
       }
}/*end menu loop*/

reg=checkered();   /*check BS'd region code and get cur # players*/
if(reg==0xFF) erratta(6);
system("CLS");
fflush(stdin);

/*stat grab*/
if(c>1) statistic(reg);

/*send region to grab... stuff*/
else grabbity(reg);

}/*end evil for loop of doom*/
}/*End main()*/



/*checks if upload routine embedded
if not, does it for you
returns number of tracks already loaded*/
int checkered()
{unsigned long x;
int reg;

/*region detection
you could check the rom header for region, or anything different really*/
/*do fakey checksum check for region - don't have full rom support yet*/
  printf("\nWait a second while some checks are run.\n");
  InitGSComms();
  ReadWriteByte(1);
  x=Read32(0xB0000010);
        
  /*NTSC Japan: reg=0*/
  if(x ==0xA24FA823) reg=0;

  /*NTSC North America: reg=1*/
  else if(x ==0xDCBC09FD) reg=1;
         
  /*PAL Europe: reg=2*/
  else if(x ==0x01142E57) reg=2;
  else reg=0xFF;

ReadWrite32(0);
ReadWrite32(0);
CloseGSComms();
return reg;}

/*Grab and display all player's position data to screen*/
int grabbity(int reg)
{unsigned long addy,x,position;
short y,c;
unsigned char z;
float radian;
/*messy, but I'm sick of it not reading these properly*/
union stupid{long lg; float ft;};
stupid scale,pos;

/*region codes*/
unsigned long ScaleAddy[]={0x80040F74,0x800413F4,0x8003AC44};
unsigned long BONDAddy[]={0x80079F50,0x80079EE0,0x800689F0};
radian= float(M_PI / 180);

  InitGSComms();
  ReadWriteByte(1);
  scale.lg=Read32(ScaleAddy[reg]);
  if(scale.lg==0) erratta(3);
for(c=0;c<4;c++)           /*messy, but it gets the job done*/
  {x=Read32(BONDAddy[reg]+(c * 4));   /*BONDdata offset*/
  if(x==0) continue;        /*continue if player data not available*/
  addy=Read32(x+0xA8);      /*offset to BOND8006*/
  if(addy==0) continue;        /*make sure they're loaded*/
  printf("Player %i data\t%X\t%X\n",c+1,x,addy);
  pos.lg=Read32(addy+0x8);
  position=pos.lg;
  pos.ft=rintf(pos.ft * scale.ft);
  printf("xpos\t%X\t%X\n",position,pos.lg);       /*x position*/
  pos.lg=Read32(addy+0xC);
  position=pos.lg;
  pos.ft=rintf(pos.ft * scale.ft);
  printf("ypos\t%X\t%X\n",position,pos.lg);       /*y position*/
  pos.lg=Read32(addy+0x10);
  position=pos.lg;
  pos.ft=rintf(pos.ft * scale.ft);
  printf("zpos\t%X\t%X\n",position,pos.lg);       /*z position*/
  scale.lg=Read32(x+0x148);
  position=scale.lg;
  pos.lg=Read32(x+0x158);
  printf("lateral\t%f deg.\tvertical\t%f deg.",scale.ft,pos.ft);
  if(scale.ft < 180) scale.ft=copysignf(scale.ft,-1.0);
  scale.ft*=radian;
  pos.ft*=radian;
  printf("\nXrot\t%X\tYrot\t%X\t",scale.lg, pos.lg);
  scale.ft= sqrtf(fabsf((scale.ft * scale.ft)-1));
  pos.lg=position;
  if(pos.ft < 270 && pos.ft > 90) scale.ft=copysignf(scale.ft,-1.0);
  printf("Zrot: %X\n",scale.lg);     /*z rotation*/
  x=Read32(addy+0x14);
  printf("room\t%X\t",x);       /*general room pointer*/
  if(x!=0)
    {y=Read16(x);
    z=ReadByte(x+2);
    printf("%04X%02X\tP%i%c",y,z,y,(z/8)+0x61);
    if(z%8) printf("%i",z%8);
     }
  printf("\n\n");
  }              /*end display info*/
  
  ReadWrite32(0);
  ReadWrite32(0);
  CloseGSComms();
  system("PAUSE"); 
return 0;}

int statistic(int reg)
{int c;
unsigned long addy,x;
union stupid{float ft; long lt;} y;

unsigned long STATaddy[]={0x80079F60,0x80079EF0,0x80068A00};
unsigned long Players[]={0x8002B560,0x8002B523,0x80026A70};

    InitGSComms();
    ReadWriteByte(1);
    c=ReadByte(Players[reg]);
    addy=STATaddy[reg];
    
    for(;c>0;c--)/*display each set of stats*/
       {y.lt=Read32(addy+0x38);
       x=ReadByte(addy+0x69);
       printf("Player %i Statistics\t%X\n%sDistance Travelled: %f\n\n",3-c,addy,x>0 ? "Currently Control Flag/Golden Gun\n":"",y.ft);
       printf("Shots Fired: %i\nHead:\t%i\tBody:\t%i\nLimb:\t%i\tOther:\t%i\nBack Shots and Explosions: %i\n",Read32(addy),Read32(addy+0x4),Read32(addy+0x8),Read32(addy+0xC),Read32(addy+0x10),Read32(addy+0x3C));
       y.lt=Read32(addy);
       if(y.lt!=0)          /*so long as you fired, pull some accuracy info*/
         {x=Read32(addy+0x4)+Read32(addy+0x8)+Read32(addy+0xC)+Read32(addy+0x10);
         x*=100;
         printf("Approximate Accuracy:\t%f\%\n",(float)x/(float)y.lt);
         }
       x=Read32(addy+0x44)/60;
       printf("\nKills: %i\t-At Once %i\n%s:\t%i",Read32(addy+0x1C),Read32(addy+0x58),(3-c)==1 ? "Suicides":"Player 1",Read32(addy+0x24));
       printf("\t%s:\t%i",(3-c)==2 ? "Suicides":"Player 2",Read32(addy+0x28));
       printf("\n%s:\t%i",(3-c)==3 ? "Suicides":"Player 3",Read32(addy+0x2C));
       printf("\t%s:\t%i\nTime b/w Kills:\t",(3-c)==4 ? "Suicides":"Player 4",Read32(addy+0x30));
       if(x!=0x2222222) printf("%i:%02i\t",x/60,x%60);
       x=Read32(addy+0x48)/60;
       printf("%i:%02i",x/60,x%60);
       x=Read32(addy+0x4C)/60;
       printf("\n\nInnings:\t%i:%02i\t",x/60,x%60);
       x=Read32(addy+0x50)/60;
       if(x!=0x2222222) printf("%i:%02i",x/60,x%60);
       x=Read32(addy+0x34)/60;
       printf("\nTime in Enemy's view:\t%i:%02i\n",x/60,x%60);
       x=Read32(addy+0x60)/60;
       y.lt=Read32(addy+0x40);
       printf("Flag Time:\t%i:%02i\nBody Armor Pickups: %.0f\n\n",x/60,x%60,y.ft);
       system("PAUSE");
       system("CLS");
       addy+=0x70;
       }
       
ReadWrite32(0);/*clean up comms*/
ReadWrite32(0);
CloseGSComms();
return 0;}

/*common errors*/
int erratta(int code)
{switch(code)
       {default:/*unspecified for some reason*/
                break;
       case 0:  /*why did you call this again?*/
            return 0;
            break;
       case 1: /*failed init - timeout*/
             fprintf(stderr,"\nTimeout Error!\n");
             fprintf(stderr,"\nCan't connect to GS.\nCheck your cable and make sure code generator is ON.\nIf you're in the GS menus, exit them and try again");
             break;
       case 2:     /*failed init - Comms Not Detected*/
            fprintf(stderr,"\nComms Not Detected!\n");            
            fprintf(stderr,"\nCan't connect to GS.\nCheck your cable and make sure code generator is ON.\nIf you're in the GS menus, exit them and try again");
            break;
       case 3:    /*some sort of stupid data returned*/
            fprintf(stderr,"\nBad data!\n");
            fprintf(stderr,"\nThe data pulled is, well, screwy.  Can't say why\n");
            break;
       case 4:    /*shorten up your filenames! - nonterminal*/
            fprintf(stderr,"\nThat file is grumpy.  It couldn't be opened properly.\n");
            fprintf(stderr,"\nThe directory leading to the file may be too long.\nSet this stuff as close to your drive letter as possible.\nThis is a console program after all\n");
            return 0;
            break;
       case 5:    /*can't let go of comms*/
            fprintf(stderr,"\nThe comms are buggered so they can't be disconnected\nSorry to say, you'll likely need to restart the game\nsorry for the inconvenience...\n");
            break;
       case 6:    /*Wrong game, or at least wrong version*/
            fprintf(stderr,"\nHmm...  Either this isn't Goldeneye, you have an unsupported version of the game, or the read failed miserably.");
            fprintf(stderr,"\nGrab the correct game and try again!\n");
            break;
       }

CloseGSComms();
Out32(LPT1,0);
fprintf(stderr,"\naborting...\n");
system("PAUSE");
exit(1);
}

/*****************************************
Generic comms functions courtesy of hcs
http://sourceforge.net/projects/N64dev
nifty, eh?
*****************************************/

/*call to initialize comms
This locks the game and allows PC access
You must re-initialize between read/write to reset pipe*/
int InitGSComms() {
	int timeout=0x80;/*change this to fiddle with general timeout value*/
	while (GSFcn1(3) && timeout) {
		timeout--;
		/*15 second warning...*/
		if(timeout==0x20) printf("\napprox seconds remaining before timeout:   %2d",timeout);
		if(timeout<=0x20) printf("\b\b%2d",timeout);
	}
	if (!timeout) erratta(1);
	if (!CheckGSPresence()) erratta(2);
	stateflag=0;
    return 0;
}

/*closing comms cuts the stream.  
You only really need to do it when all access is complete
Therefore, read&write all day long, then kill stream at the very end*/
int CloseGSComms(void) {
    if (stateflag) return 0;
    stateflag=1;
	if (GSFcn1(3)|(!CheckGSPresence())) erratta(5);
	ReadWriteByte(0x64);
    Out32(LPT1,0);      /*blank out the LPT*/
    return 0;
}

/*checks for sync*/
int GSFcn1(int x) {
	int timeout=0x28;
	unsigned char result;
	
	while (timeout) {
		result<<=4;
		result|=SendNibble(x);
		/* when we recieve a 6, then a 7, we're sync'd*/
		if (result==0x67) break;

		SendNibble(x);
		SendNibble(x>>4);

		timeout--;
	}

	if (!timeout) return 1;
	return 0;
}

int SendNibble(int x) {
	int timeout=0x3e8,retval;
	
	Out32(LPT1,x&0xf|0x10);

	while (timeout && Inp32(LPT1+1)&8) timeout--;
	
	retval=(Inp32(LPT1+1)&0xf0^0x80)>>4;

	Out32(LPT1,0);

	timeout=0x64;
	while (timeout && Inp32(LPT1+1)&8) timeout--;

	if (!timeout) return 0;
	else return retval;
}

int ReadWriteNibble(int x) {
	int retval;
	Out32(LPT1,x&0xf|0x10);
	
	while ((~Inp32(LPT1+1))&8);
	while ((~Inp32(LPT1+1))&8);

	retval=(Inp32(LPT1+1)&0xf0^0x80)>>4;

	Out32(LPT1,0);

	while (Inp32(LPT1+1)&8);
	while (Inp32(LPT1+1)&8);

	return retval;
}

int ReadWriteByte(int x) {
	return (ReadWriteNibble(x>>4)<<4)|ReadWriteNibble(x);
}

unsigned int ReadWrite16(unsigned int x) {
	return ((ReadWriteNibble(x>>12)<<12)|(ReadWriteNibble(x>>8)<<8)|(ReadWriteNibble(x>>4)<<4)|ReadWriteNibble(x));
}

unsigned long ReadWrite32(unsigned long x) {
	return ((unsigned long)ReadWriteNibble(x>>28)<<28)|((unsigned long)ReadWriteNibble(x>>24)<<24)|((unsigned long)ReadWriteNibble(x>>20)<<20)|((unsigned long)ReadWriteNibble(x>>16)<<16)|((unsigned long)ReadWriteNibble(x>>12)<<12)|((unsigned long)ReadWriteNibble(x>>8)<<8)|((unsigned long)ReadWriteNibble(x>>4)<<4)|(unsigned long)ReadWriteNibble(x);
}


/* this breaks when the GS can allow ram access*/
int CheckGSPresence(void) {
	int timeout=0x3e8,result;
	
	while (timeout) {
		result=(ReadWriteNibble(0x47>>4)<<4)|ReadWriteNibble(0x47);
		timeout--;
		if (result != 0x67) continue;
		result=(ReadWriteNibble(0x54>>4)<<4)|ReadWriteNibble(0x54);
		if (result == 0x74) break;
	}

/*	printf("\nGS utilities can't be used while in the GS menu.\n");*/
	if (timeout) return 1;
	return 0;
}

/*these are simple read/write types as above, but don't initiate or close the comms
  heck, they could probably just be implemented as macros if you get right to it...
  These are slightly faster, but the others are more robust*/
unsigned long Read32(unsigned long address) {
	ReadWrite32(address);
	ReadWrite32(4);
	return ReadWrite32(0);
}


unsigned short Read16(unsigned long address) {
	ReadWrite32(address);
	ReadWrite32(2);
	return ReadWrite16(0);
}


unsigned char ReadByte(unsigned long address)
{ReadWrite32(address);
ReadWrite32(1);
return ReadWriteByte(0);
}
